# $Id: autoraise.tcl 101 2007-03-29 00:21:42Z kostix $
# "Auto raise on new messages" plugin for Tkabber.
# Written by Konstantin Khomoutov <flatworm@users.sourceforge.net>
# See README for details.

# From: http://wiki.tcl.tk/16978
proc ::params proc {
	set params [list]
	foreach param [info args $proc] {
		if {[info default $proc $param default]} {
			lappend params [list $param $default]
		} else {
			lappend params $param
		}
	}
	return $params
}

proc ::prepend_proc {proc code} {
	set p [namespace origin $proc]
	append code \n [info body $p]
	proc $p [params $p] $code
}

namespace eval autoraise {
	variable autoraise

	custom::defvar autoraise 1 \
		[::msgcat::mc "Auto raise Tkabber on new messages"] \
		-group IFace \
		-type boolean

	# It can blow if the actual namespace of the autoraise
	# variable contains weird characters like curly brace:
	hook::add postload_hook [namespace code {
		prepend_proc tab_set_updated [format {
			if {![winfo ismapped .] && ${%s}} { wm deiconify . }
		} [namespace current]::autoraise]
	}]

	hook::add finload_hook [namespace code {
		set tm [.mainframe getmenu tkabber]
		set vm [$tm entrycget [::msgcat::mc "View"] -menu]
		$vm insert end checkbutton \
			-label [::msgcat::mc "Auto raise on new messages"] \
			-variable [namespace current]::autoraise
	}]
}

